<template>
    <!-- 导入表 -->
    <el-dialog :title="$t('gen.import.832346-0')" :visible.sync="visible" width="850px" top="5vh" append-to-body>
        <el-form :model="queryParams" ref="queryForm" :inline="true">
            <el-form-item prop="dataName">
                <el-select v-model="queryParams.dataName" size="small" :placeholder="$t('views.iot.bridge.index.525282-51')" style="width: 100%" :clearable="true">
                    <el-option v-for="(item, index) in dataSources" :key="index" :label="item" :value="item"></el-option>
                </el-select>
            </el-form-item>
            <el-form-item prop="tableName">
                <el-input v-model="queryParams.tableName" size="small" :placeholder="$t('gen.import.832346-2')" clearable @keyup.enter.native="handleQuery" />
            </el-form-item>
            <el-form-item>
                <el-button type="primary" size="small" icon="el-icon-search" @click="handleQuery">{{ $t('search') }}</el-button>
                <el-button icon="el-icon-refresh" size="small" @click="resetQuery">{{ $t('reset') }}</el-button>
            </el-form-item>
        </el-form>
        <el-row>
            <el-table @row-click="clickRow" ref="table" :data="dbTableList" @selection-change="handleSelectionChange" size="small" :border="false">
                <el-table-column type="selection" width="55"></el-table-column>
                <el-table-column prop="tableName" :label="$t('gen.import.832346-1')" :show-overflow-tooltip="true" min-width="150px"></el-table-column>
                <el-table-column prop="tableComment" :label="$t('gen.import.832346-3')" :show-overflow-tooltip="true" min-width="150px"></el-table-column>
                <el-table-column prop="createTime" :label="$t('creatTime')" align="center" min-width="90px"></el-table-column>
                <el-table-column prop="updateTime" :label="$t('gen.import.832346-5')" align="center" min-width="90px"></el-table-column>
            </el-table>
            <pagination v-show="total > 0" layout="prev, pager, next" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize" @pagination="getList" />
        </el-row>
        <div slot="footer" class="dialog-footer">
            <el-button type="primary" @click="handleImportTable">{{ $t('confirm') }}</el-button>
            <el-button @click="visible = false">{{ $t('cancel') }}</el-button>
        </div>
    </el-dialog>
</template>

<script>
import { listDbTable, importTable, listDataSource } from '@/api/tool/gen';
export default {
    data() {
        return {
            // 遮罩层
            visible: false,
            // 选中数组值
            tables: [],
            // 总条数
            total: 0,
            // 表数据
            dbTableList: [],
            dataSources: [],
            // 查询参数
            queryParams: {
                pageNum: 1,
                pageSize: 10,
                tableName: undefined,
                tableComment: undefined,
                dataName: 'master',
            },
        };
    },
    methods: {
        // 显示弹框
        show() {
            this.resetForm('queryForm');
            this.getList();
            this.handleDataSource(); //获取数据源
            this.visible = true;
        },
        clickRow(row) {
            this.$refs.table.toggleRowSelection(row);
        },
        // 多选框选中数据
        handleSelectionChange(selection) {
            this.tables = selection.map((item) => item.tableName);
        },
        // 查询表数据
        getList() {
            listDbTable(this.queryParams).then((res) => {
                if (res.code === 200) {
                    this.dbTableList = res.rows;
                    this.total = res.total;
                }
            });
        },
        /** 搜索按钮操作 */
        handleQuery() {
            this.queryParams.pageNum = 1;
            this.getList();
        },
        /** 重置按钮操作 */
        resetQuery() {
            this.resetForm('queryForm');
            this.handleQuery();
        },
        //获取数据源
        handleDataSource() {
            this.loading = true;
            listDataSource().then((response) => {
                this.dataSources = response.data;
                this.loading = false;
            });
        },
        /** 导入按钮操作 */
        handleImportTable() {
            const tableNames = this.tables.join(',');
            const params = {
                tables: tableNames,
                dataName: this.queryParams.dataName,
            };
            if (tableNames == '') {
                this.$modal.msgError(this.$t('gen.import.832346-6'));
                return;
            }
            importTable(params).then((res) => {
                this.$modal.msgSuccess(res.msg);
                if (res.code === 200) {
                    this.visible = false;
                    this.$emit('ok');
                }
            });
        },
    },
};
</script>
